import * as MongoDB from 'mongodb';
import { IQueryResult } from '../interfaces/IQueryResult';
import Model from './Model';
export default class Collection<T extends Model<any, any>> {
    collection: MongoDB.Collection<ReturnType<T['toServer']>>;
    modelConstructor: new (collection?: Collection<T>) => T;
    constructor(collection: MongoDB.Collection<ReturnType<T['toServer']>>, modelConstructor: new (collection?: Collection<T>) => T);
    create(): T;
    insert(model: T): Promise<MongoDB.InsertOneWriteOpResult<Pick<ReturnType<T["toServer"]>, Exclude<keyof ReturnType<T["toServer"]>, "_id">> & {
        _id: ReturnType<T["toServer"]> extends {
            _id: infer U;
        } ? {} extends U ? Exclude<U, {}> : unknown extends U ? MongoDB.ObjectID : U : MongoDB.ObjectID;
    }>>;
    update(id: string | MongoDB.ObjectId, model: T, overwrite?: boolean): Promise<MongoDB.UpdateWriteOpResult>;
    findOne(query: Partial<ReturnType<T['toServer']>>): Promise<T>;
    get(id: string | MongoDB.ObjectId): Promise<T>;
    list(params: {
        find: Partial<ReturnType<T['toServer']>>;
        offset: number;
        limit: number;
        sort: any;
    }): Promise<IQueryResult<T>>;
    delete(id: string | MongoDB.ObjectId): Promise<MongoDB.DeleteWriteOpResultObject>;
}
