"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const MongoDB = require("mongodb");
class CollectionFactory {
    constructor() {
        this.collections = {};
    }
    async connect(uri, dbName) {
        this.client = await MongoDB.MongoClient.connect(uri, {
            useNewUrlParser: true,
            useUnifiedTopology: true
        });
        this.db = this.client.db(dbName);
    }
    close() {
        this.collections = {};
        return this.client.close();
    }
    getCollection(collectionName) {
        if (!this.collections[collectionName]) {
            this.collections[collectionName] = this.db.collection(collectionName);
        }
        return this.collections[collectionName];
    }
}
exports.default = CollectionFactory;
//# sourceMappingURL=CollectionFactory.js.map