import * as MongoDB from 'mongodb';
import { IClientData, IData } from "../interfaces/IData";
import ModelDefinition from './ModelDefinition';
import Collection from "./Collection";
import CollectionFactory from './CollectionFactory';
export default class Model<T extends IClientData, U extends IData<T> = IData<T>, V extends Collection<Model<T, U, any>> = Collection<Model<T, U, any>>> {
    _modelDefinition: ModelDefinition;
    _collection: V;
    _baseData: Partial<T>;
    _id: MongoDB.ObjectId;
    constructor(collection?: V);
    reset(): void;
    update(): void;
    diff(): Partial<T>;
    getKeys(): any;
    getConfig(key: keyof ThisType<T>): import("./ModelDefinition").IPropertyConfig<any, any, any, any, any, any>;
    getConfigs(): {
        [index: string]: import("./ModelDefinition").IPropertyConfig<any, any, any, any, any, any>;
    };
    validate(): any[];
    build(collectionFactory: CollectionFactory, references: string | string[]): void;
    fromClient(data: Partial<T>): void;
    toClient(hide?: boolean, references?: boolean | string | string[]): T;
    fromServer(data: Partial<U>): void;
    toServer(hide?: boolean, references?: boolean | string | string[]): U;
    toJSON(): T;
    save(overwrite?: boolean): Promise<MongoDB.UpdateWriteOpResult | MongoDB.InsertOneWriteOpResult<Pick<U, Exclude<keyof U, "_id">> & {
        _id: U extends {
            _id: infer U_1;
        } ? {} extends U_1 ? Exclude<U_1, {}> : unknown extends U_1 ? MongoDB.ObjectID : U_1 : MongoDB.ObjectID;
    }>>;
    delete(): Promise<void>;
    beforeSave(): void;
    beforeInsert(): void;
    beforeUpdate(overwrite?: boolean): void;
    beforeDelete(): void;
}
