"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ModelDefinition {
    constructor(parent) {
        this.propertyConfigs = {};
        this.parent = parent;
    }
    getKeys() {
        if (this.parent) {
            return this.parent.getKeys().concat(Object.keys(this.propertyConfigs));
        }
        else {
            return Object.keys(this.propertyConfigs) || [];
        }
    }
    getConfigs() {
        let configHash;
        if (this.parent) {
            configHash = this.parent.getConfigs();
        }
        else {
            configHash = {};
        }
        Object.assign(configHash, this.propertyConfigs);
        return configHash;
    }
    getConfig(key) {
        return this.propertyConfigs[key];
    }
    addConfig(key, config) {
        this.propertyConfigs[key] = config;
    }
    static getModelDefinition(target) {
        if (target._modelDefinition) {
            if (!target.hasOwnProperty('_modelDefinition')) {
                target._modelDefinition = new ModelDefinition(target._modelDefinition);
            }
        }
        else {
            target._modelDefinition = new ModelDefinition();
        }
        return target._modelDefinition;
    }
}
exports.default = ModelDefinition;
//# sourceMappingURL=ModelDefinition.js.map