import { Controller } from 'sierra';
import * as MongoDB from 'mongodb';
import Collection from './Collection';
import Model from './Model';
export default class Service<T extends Model<any, any>, V extends Collection<T> = Collection<T>> extends Controller {
    collection: V;
    constructor(base: string, collection: V);
    index(offset: string, limit: string, sortedColumn: string, sortedDirection: any): Promise<import("../SierraData").IQueryResult<T>>;
    get(id: string): Promise<T>;
    post($body: ReturnType<T['toClient']>): Promise<MongoDB.ObjectID>;
    put(id: string, $body: Partial<ReturnType<T['toClient']>>): Promise<boolean>;
    delete(id: string): Promise<boolean>;
}
