"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const sierra_1 = require("sierra");
const MongoDB = require("mongodb");
class Service extends sierra_1.Controller {
    constructor(base, collection) {
        super(base);
        this.collection = collection;
    }
    async index(offset, limit, sortedColumn, sortedDirection) {
        let _offset = parseInt(offset);
        let _limit = parseInt(limit);
        if (!_limit || isNaN(_limit) || !isFinite(_limit)) {
            _limit = 20;
        }
        return this.collection.list({
            find: {},
            offset: _offset,
            limit: _limit,
            sort: (function () {
                if (sortedColumn) {
                    var output = {};
                    output[sortedColumn] = (sortedDirection === undefined || sortedDirection) ? 1 : -1;
                    return output;
                }
            })()
        });
    }
    async get(id) {
        let _id = new MongoDB.ObjectId(id);
        let model = await this.collection.get(_id);
        return model;
    }
    async post($body) {
        let model = this.collection.create();
        model.fromClient($body);
        await model.save();
        return model._id;
    }
    async put(id, $body) {
        let model = this.collection.create();
        model.fromClient($body);
        model._id = new MongoDB.ObjectId(id);
        await model.save(true);
        return true;
    }
    async delete(id) {
        let _id = new MongoDB.ObjectId(id);
        await this.collection.delete(_id);
        return true;
    }
}
__decorate([
    sierra_1.method('get'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String, Object]),
    __metadata("design:returntype", Promise)
], Service.prototype, "index", null);
__decorate([
    sierra_1.method('get', '/:id'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], Service.prototype, "get", null);
__decorate([
    sierra_1.method('post'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [void 0]),
    __metadata("design:returntype", Promise)
], Service.prototype, "post", null);
__decorate([
    sierra_1.method('put', '/:id'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", Promise)
], Service.prototype, "put", null);
__decorate([
    sierra_1.method('delete', '/:id'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], Service.prototype, "delete", null);
exports.default = Service;
//# sourceMappingURL=Service.js.map